/*
 * Copyright  2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 *  
 */

/*
 * Created on Feb 9, 2005
 *
 */
package com.sunlabs.archsim.tests.arbiter;

import java.util.Iterator;

import com.sunlabs.archsim.base.simulation.Delay;
import com.sunlabs.archsim.gasp.Action;
import com.sunlabs.archsim.gasp.Function;
import com.sunlabs.archsim.gasp.Terminal;


/**
 * @author ib27688
 *
 */
public class ArbiterTestAction extends Action {
	
	public ArbiterTestAction(String name) {
		super(name);
		outputFunctions.put(ArbiterTestGlobal.DATA_OUT_TERMINAL_NAME,
							new PassData());
		outputFunctions.put(ArbiterTestGlobal.ACK_DATA_IN_TERMINAL_NAME, 
				new ActionFired());
	} // ArbiterTestAction
	
	
	/** Simply pass the data from input terminal 0 */
	private class PassData extends Function {
		
		public PassData() {
			super("PassData");
			functionDelay= new Delay(10); // was 10
		}
		
		public Object value() {
			Iterator ti= terminals.iterator();
			boolean found= false;
			Terminal t= null;
			while (!found && ti.hasNext()) {
				t= (Terminal)(ti.next());
				if (t.getBaseName() == ArbiterTestGlobal.DATA_IN_TERMINAL_NAME) {
					found= true;
				}
			}
			if (found) {
				return t.getData();
			}
			else {
				director.journal("ERROR: function " + getName()
						+ " could not found terminal "
						+ ArbiterTestGlobal.DATA_OUT_TERMINAL_NAME
						+ " attached to action "
						+ ArbiterTestAction.this.getName() + ", id= "
						+ ArbiterTestAction.this.getID());
				director.stop();			
				return null;
			}
		} // value
	} // PassData

	/** Vacuous function used to acknowldge that the action has fired */ 
	private class ActionFired extends Function {
		
		public ActionFired() {
			super("Vacous");
			functionDelay= new Delay(0); // was 10
		}
	
		public Object value() {
			return null;
		} // value
	} // AcknowledgeData
	
} // ArbiterTestAction
